﻿Option Strict On
Imports Microsoft.Phone.Tasks
Imports System.Windows.Media.Imaging
Imports ImageTools
Imports ImageTools.Filtering
Imports System.IO.IsolatedStorage
Imports Microsoft.Xna.Framework.Media
Imports System.IO

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub
    Dim myTask As PhotoChooserTask
    Dim loadImage As ExtendedImage
    Dim filterImage As ExtendedImage

    Dim myImage As BitmapImage
    'Dim no As Integer = 0
    'Dim no2 As Integer = 0

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        myTask = New PhotoChooserTask
        AddHandler myTask.Completed, Sub(resultSender As Object, resultArgs As PhotoResult)
                                         If resultArgs.TaskResult = TaskResult.OK Then
                                             myImage = New BitmapImage
                                             myImage.SetSource(resultArgs.ChosenPhoto)
                                             Image1.Source = myImage
                                             Dim wb As WriteableBitmap = New WriteableBitmap(myImage)
                                             loadImage = New ExtendedImage
                                             loadImage.SetPixels(myImage.PixelWidth, myImage.PixelHeight, wb.ToByteArray())

                                         End If
                                     End Sub
        MyBase.OnNavigatedTo(e)
    End Sub


    Private Sub imageReadButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles imageReadButton.Click
        myTask.Show()
        ListBox1.IsEnabled = True
    End Sub




    Private Sub ListBox1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox1.SelectionChanged
        Dim myItem As String = DirectCast(ListBox1.SelectedItem, ListBoxItem).Content.ToString

        Select Case myItem
            Case "セピア"
                'Slider1.Visibility = Windows.Visibility.Collapsed
                'Slider2.Visibility = Windows.Visibility.Collapsed
                Dim filter As Sepia
                filter = New Sepia
                filterImage = New ExtendedImage(loadImage)

                filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
            Case "インバーター"
                'Slider1.Visibility = Windows.Visibility.Collapsed
                'Slider2.Visibility = Windows.Visibility.Collapsed
                Dim filter As Inverter
                filter = New Inverter
                filterImage = New ExtendedImage(loadImage)

                filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
            Case "白黒"
                'Slider1.Visibility = Windows.Visibility.Collapsed
                'Slider2.Visibility = Windows.Visibility.Collapsed
                Dim filter As Grayscale
                filter = New GrayscaleRMY
                filterImage = New ExtendedImage(loadImage)
                filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
                'Case "補間"
                '    Slider1.Visibility = Windows.Visibility.Collapsed
                '    Slider2.Visibility = Windows.Visibility.Collapsed
                '    Dim filter As NearestNeighborResizer
                '    filter = New NearestNeighborResizer
                '    filterImage = New ExtendedImage(loadImage)
                '    filter.Resize(filterImage, loadImage, loadImage.PixelWidth, loadImage.PixelHeight)
            Case "プルウィットX"
                'Slider1.Visibility = Windows.Visibility.Collapsed
                'Slider2.Visibility = Windows.Visibility.Collapsed
                Dim filter As PrewittX
                filter = New PrewittX
                filterImage = New ExtendedImage(loadImage)
                filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))

            Case "プルウィットY"
                Dim filter As PrewittY
                filter = New PrewittY
                filterImage = New ExtendedImage(loadImage)
                filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))

            Case "ソーベルX"
                'Slider1.Visibility = Windows.Visibility.Collapsed
                'Slider2.Visibility = Windows.Visibility.Collapsed
                Dim filter As SobelX
                filter = New SobelX
                filterImage = New ExtendedImage(loadImage)
                filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
            Case "ソーベルY"
                'Slider1.Visibility = Windows.Visibility.Collapsed
                'Slider2.Visibility = Windows.Visibility.Collapsed
                Dim filter As SobelY
                filter = New SobelY
                filterImage = New ExtendedImage(loadImage)
                filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))

                'Case "ブライトネス"

                '    Slider1.Visibility = Windows.Visibility.Visible
                '    Dim filter As Brightness
                '    filter = New Brightness(no)
                '    filterImage = New ExtendedImage(loadImage)
                '    filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
                'Case "コントラスト"
                '    Slider2.Visibility = Windows.Visibility.Visible
                '    Dim filter As Contrast
                '    filter = New Contrast(no2)
                '    filterImage = New ExtendedImage(loadImage)
                '    filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
            Case Else
                Exit Select
        End Select


        Dim bitmap As WriteableBitmap = filterImage.ToBitmap
        Image1.Source = bitmap

        saveButton.IsEnabled = True
    End Sub

    Private Sub saveButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles saveButton.Click
        Dim imageFileName As String = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"

        Dim myWriteableBitmap As WriteableBitmap
        myWriteableBitmap = New WriteableBitmap(Image1, Nothing)

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.FileExists(imageFileName) = True Then
            storage.DeleteFile(imageFileName)
        End If
        Using myStream As IsolatedStorageFileStream = storage.CreateFile(imageFileName)
            System.Windows.Media.Imaging.Extensions.SaveJpeg(myWriteableBitmap, myStream, myWriteableBitmap.PixelWidth, myWriteableBitmap.PixelHeight, 0, 85)
        End Using

        Dim myLibray As New MediaLibrary
        Using Stream As IsolatedStorageFileStream = storage.OpenFile(imageFileName, FileMode.Open, FileAccess.Read)
            myLibray.SavePicture(imageFileName, Stream)
            MessageBox.Show("PicturesHubに保存しました。")
        End Using
    End Sub

    'Private Sub Slider1_ValueChanged(sender As Object, e As System.Windows.RoutedPropertyChangedEventArgs(Of Double)) Handles Slider1.ValueChanged
    '    Dispatcher.BeginInvoke(Sub()
    '                               no = CInt(Slider1.Value)
    '                               Dim filter As Brightness
    '                               filter = New Brightness(no)
    '                               filterImage = New ExtendedImage(loadImage)
    '                               filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
    '                               Dim bitmap = filterImage.ToBitmap
    '                               Image1.Source = bitmap
    '                           End Sub)
    'End Sub

    'Private Sub Slider2_ValueChanged(sender As Object, e As System.Windows.RoutedPropertyChangedEventArgs(Of Double)) Handles Slider2.ValueChanged
    '    Dispatcher.BeginInvoke(Sub()
    '                               no2 = CInt(Slider2.Value)
    '                               Dim filter As Contrast
    '                               filter = New Contrast(no2)
    '                               filterImage = New ExtendedImage(loadImage)
    '                               filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
    '                               Dim bitmap = filterImage.ToBitmap
    '                               Image1.Source = bitmap
    '                           End Sub)
    'End Sub
End Class
